# Nextclade dataset for "Mpox virus (Lineage B.1)"

| Key                    | Value                                                                                                                 |
| ---------------------- | --------------------------------------------------------------------------------------------------------------------- |
| authors                | [Cornelius Roemer](https://neherlab.org), [Richard Neher](https://neherlab.org), [Nextstrain](https://nextstrain.org) |
| data source            | Genbank                                                                                                               |
| workflow               | [github.com/nextstrain/mpox/nextclade](https://github.com/nextstrain/mpox/nextclade)                                  |
| nextclade dataset path | nextstrain/mpox/lineage-b.1                                                                                            |
| annotation             | [NC_063383.1](https://www.ncbi.nlm.nih.gov/nuccore/NC_063383)                                                         |
| clade definitions      | [github.com/mpxv-lineages/lineage-designation](https://github.com/mpxv-lineages/lineage-designation)                  |
| related datasets       | Mpox virus (All clades): `nextstrain/mpox/all-clades`<br> Mpox virus (Clade IIb) `nextstrain/mpox/clade-iib`        |

## Scope of this dataset

This dataset is for Mpox viruses of the 2022-2023 outbreak lineage B.1. Two broader datasets for clade IIb and all clades are available as well: `nextstrain/mpox/clade-iib` for Clade IIb and `nextstrain/mpox/all-clades` for all clades (I, IIa and IIb).

## Reference sequence and reference tree

The reference used in this dataset is the clade IIb NCBI refseq `NC_063383.1` (Isolate `MPXV-M5312_HM12_Rivers`) with all B.1 defining SNPs added to make the mutation view less cluttered.

The reference tree consists of around 1000 sequences with representatives from all B.1 sublineages.

## Further reading

The lineage system used is defined in [Happi et al. (2022)](https://doi.org/10.1371/journal.pbio.3001769). Lineage definitions are available at [github.com/mpxv-lineages/lineage-designation](https://github.com/nextstrain/mpox/nextclade).

Read more about Nextclade datasets in Nextclade documentation: https://docs.nextstrain.org/projects/nextclade/en/stable/user/datasets.html
